/*
 * analogue_clock.h
 *
 * Copyright (C) 2011 Tim Marston <tim@ed.am> and Dan Marston.
 *
 * This file is part of propeller-clock (hereafter referred to as "this
 * program"). See http://ed.am/dev/software/arduino/propeller-clock for more
 * information.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _ANALOGUE_CLOCK_H_
#define _ANALOGUE_CLOCK_H_


/**
 * Called to inform the mode that there has been a (short) button press.
 */
extern void analogue_clock_press();

/**
 * Draw an individual segment (column of pixels)
 *
 * @param segment the segment number
 */
extern void analogue_clock_draw( int segment );

/**
 * Called before the first segment is drawn, once per "frame".
 */
extern void analogue_clock_draw_reset();


#endif //_ANALOGUE_CLOCK_H_
