/*
 * digital_clock.cc
 *
 * Copyright (C) 2011 Tim Marston <tim@ed.am> and Dan Marston.
 *
 * This file is part of propeller-clock (hereafter referred to as "this
 * program"). See http://ed.am/dev/software/arduino/propeller-clock for more
 * information.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "digital_clock.h"
#include "common.h"
#include "text.h"
#include "text_renderer.h"
#include "time.h"


// font flavour
static int _flavour = 0;


static void set_message( bool update )
{
	PString str0( Text::_messages[ 0 ], MESSAGE_LEN );
//	PString str1( Text::_messages[ 1 ], MESSAGE_LEN );
	str0.begin();
//	str1.begin();
//	switch( get_flavour() )
//	{
//	case 0:
//		str0.format( "%d:%02d:%02 %s", time.get_hours() % 12,
//					time.get_minutes(), time.get_seconds(),
//					time.get_hours() / 12 > 0? "pm" : "am" );
//		Text::set_message( 0, str0 );
//		str1.print( "-" );
//		Text::set_message( 1, str1 );
//		if( update ) {
//			Text::reset_message( 0, Text::MODE_TOP +
//								 Text::MODE_ALL );
//			Text::reset_message( 1, Text::MODE_BOTTOM +
//								 Text::MODE_ONEQUARTER );
//		}
//		break;
//	case 1:
		str0.format( "%d%s %s, %d", Time::get_day(),
					Time::get_day_suffix(),
					Time::get_month_name(), Time::get_year() );
		Text::set_message( 0, str0 );
//		Text::set_message( 1, str1 );
		if( !update ) {
			Text::reset_message( 0, Text::MODE_HSCROLL | Text::MODE_TOP |
								 Text::MODE_THREEQUARTERS );
//			Text::reset_message( 1, Text::MODE_BOTTOM +
//								 Text::MODE_ONEQUARTER );
		}
//		break;
//	}

	TextRenderer::select_font( _flavour );
}


void digital_clock_press()
{
	if( ++_flavour >= 4 )
		_flavour = 0;
}


void digital_clock_draw( int segment )
{
	Text::draw( 0, segment );
//	Text::draw( 1, segment );
	TextRenderer::output_buffer();
}


void digital_clock_draw_reset()
{
	// gotta update message, the time might have changed!
	set_message( true );

	Text::draw_reset();
}


void digital_clock_activate()
{
	leds_off();

	Text::reset();
	set_message( false );
}
